unit flexglob;

{global definitions for the 8088flex programs}

interface

{
'TMAV'     - 4 bytes, header signature
samplerate - 2 bytes, word value, playback sample rate
chunksize  - 2 bytes, word value, audio chunk size per frame
compmethod - 1 byte, specifies the compression method (currently only 0)
charcols   - 1 byte, number of text chars across (currently always 40)
charrows   - 1 byte, number of text chars down (currently always 25)
features   - bitfield, reserved for special handling:

76543210
||||||||
|||||||+--(f_Padding) 
||||||+---(f_Stereo) If set, audio data is in stereo format (LRLR etc.)
|||||+----reserved
||||+-----reserved
|||+------reserved
||+-------reserved
|+--------reserved
+---------reserved

A note about f_padding:
If set, AV chunks are padded to the next 512-byte boundary.  They also start
at position 512 in the stream (so there is a lot of empty space after the
header).  This is to eliminate double-buffering on DOS's part:  If you ask
DOS for data that isn't aligned to the sector size, it reads into its
own temporary BUFFERS (so that's what they're for! ;-) and then REP MOVS
those buffers into your ES:DI.  But if the data IS aligned, it gets moved
directly into your ES:DI.  At least, that's the theory.
}


const
  headsig:array[0..3] of char='T'+'M'+'A'+'V';
  PadBoundary=512;

  {bitwise flags for feature field}
  f_padding=1;
  f_stereo=2;
  f_reserved=4;

type
  avheadrec=record
    fileheader:array[0..3] of char;
    samplerate,
    chunksize:word;
    compmethod,
    charcols,
    charrows,
    features:byte;
  end;

implementation

end.
